%define contentdir /var/www
%define with_oci8 %{?_with_oci8:1}%{!?_with_oci8:0}
%define with_mssql %{?_with_mssql:1}%{!?_with_mssql:0}
%define with_mhash %{?_with_mhash:1}%{!?_with_mhash:0}
%define with_snmp %{?_with_snmp:1}%{!?_with_snmp:1}
%define with_domxml %{?_with_domxml:1}%{!?_with_domxml:0}

%define subname apache2

Summary: The PHP HTML-embedded scripting language. (PHP: Hypertext Preprocessor)
Name: php-%{subname}
Version: 4.4.2
Release: 1.norlug
License: The PHP License
Group: Development/Languages
URL: http://www.php.net/
Epoch: 2

Source0:  http://www.php.net/distributions/php-%{version}.tar.bz2

Source50: php.conf

Patch1: php-4.2.1-ldap-TSRM.patch
Patch2: php-4.3.1-config.patch
Patch3: php-4.2.2-lib64.patch
Patch4: php-4.2.2-cxx.patch
Patch5: php-4.3.3-install.patch
Patch6: php-4.3.1-tests.patch
Patch7: php-4.3.2-libtool15.patch
Patch8: php-4.3.3-miscfix.patch
Patch9: php-4.3.4-setenv.patch
Patch10: php-4.3.4-xmlrpc.patch
# branding patch
#Patch11: php-version.patch
# libtool patch
Patch12: php-libtool.patch

# Fixes for extension modules
Patch21: php-4.3.1-odbc.patch
Patch22: php-4.3.2-db4.patch

# Functional changes
Patch30: php-4.3.1-dlopen.patch

BuildRoot: %{_tmppath}/%{name}-root

BuildRequires: bzip2-devel, curl-devel >= 7.9, db4-devel, expat-devel, freetype-devel
BuildRequires: gd-devel >= 1.8.4, gdbm-devel, gmp-devel, aspell-devel
BuildRequires: httpd-devel >= 2.0.46-1, libjpeg-devel, libpng-devel, pam-devel
BuildRequires: libstdc++-devel, ncurses-devel, openssl-devel
BuildRequires: zlib-devel, pcre-devel
BuildRequires: bzip2, fileutils, perl, libtool >= 1.4.2
Obsoletes: php-dbg, mod_php, php3, phpfi, php-manual
# Enforce Apache module ABI compatibility
Requires: httpd-mmn = %(cat %{_includedir}/httpd/.mmn || echo missing-httpd-devel)
Requires: httpd >= 2.0.46-1
Obsoletes: php-apache1
Obsoletes: mod_php, php3, phpfi, php-dbg, php

%description
PHP is an HTML-embedded scripting language. PHP attempts to make it
easy for developers to write dynamically generated webpages. PHP also
offers built-in database integration for several commercial and
non-commercial database management systems, so writing a
database-enabled webpage with PHP is fairly simple. The most common
use of PHP coding is probably as a replacement for CGI scripts. The
mod_php module enables the Apache Web server to understand and process
the embedded PHP language in Web pages.

%package devel
Group: Development/Libraries
Summary: Files needed for building PHP extensions.
AutoReq: no
Obsoletes: php-apache1-devel


%description devel
The php-devel package contains the files needed for building PHP
extensions. If you need to compile your own PHP extensions, you will
need to install this package.


%package imap
Summary: An Apache module for PHP applications that use IMAP.
Group: Development/Languages
Requires: php-%{subname} = %{version}-%{release}
Obsoletes: mod_php3-imap
Obsoletes: php-apache1-imap, php-imap
BuildRequires: krb5-devel, openssl-devel, imap-devel


%description imap
The php-imap package contains a dynamic shared object (DSO) for the
Apache Web server. When compiled into Apache, the php-imap module will
add IMAP (Internet Message Access Protocol) support to PHP. IMAP is a
protocol for retrieving and uploading e-mail messages on mail
servers. PHP is an HTML-embedded scripting language. If you need IMAP
support for PHP applications, you will need to install this package
and the php package.

%package ldap
Summary: A module for PHP applications that use LDAP.
Group: Development/Languages
Requires: php-%{subname} = %{version}-%{release}
Obsoletes: mod_php3-ldap
Obsoletes: php-apache1-ldap, php-ldap
BuildRequires: cyrus-sasl-devel, openldap-devel, openssl-devel

%description ldap
The php-ldap package is a dynamic shared object (DSO) for the Apache
Web server that adds Lightweight Directory Access Protocol (LDAP)
support to PHP. LDAP is a set of protocols for accessing directory
services over the Internet. PHP is an HTML-embedded scripting
language. If you need LDAP support for PHP applications, you will
need to install this package in addition to the php package.

%package mysql
Summary: A module for PHP applications that use MySQL databases.
Group: Development/Languages
Requires: php-%{subname} = %{version}-%{release}
Provides: php_database
Obsoletes: mod_php3-mysql
Obsoletes: php-apache1-mysql, php-mysql
BuildRequires: mysql-devel

%description mysql
The php-mysql package contains a dynamic shared object that will add
MySQL database support to PHP. MySQL is an object-relational database
management system. PHP is an HTML-embeddable scripting language. If
you need MySQL support for PHP applications, you will need to install
this package and the php or mod_php package.

%package pgsql
Summary: A PostgreSQL database module for PHP.
Group: Development/Languages
Requires: php-%{subname} = %{version}-%{release}
Provides: php_database
Obsoletes: mod_php3-pgsql
Obsoletes: php-apache1-pgsql, php-pgsql
BuildRequires: krb5-devel, openssl-devel, postgresql-devel

%description pgsql
The php-pgsql package includes a dynamic shared object (DSO) that can
be compiled in to the Apache Web server to add PostgreSQL database
support to PHP. PostgreSQL is an object-relational database management
system that supports almost all SQL constructs. PHP is an
HTML-embedded scripting language. If you need back-end support for
PostgreSQL, you should install this package in addition to the main
php package.

%package odbc
Group: Development/Languages
Requires: php-%{subname} = %{version}-%{release}
Summary: A module for PHP applications that use ODBC databases.
Provides: php_database
BuildRequires: unixODBC-devel
Obsoletes: php-apache1-odbc, php-odbc

%description odbc
The php-odbc package contains a dynamic shared object that will add
database support through ODBC to PHP. ODBC is an open specification
which provides a consistent API for developers to use for accessing
data sources (which are often, but not always, databases). PHP is an
HTML-embeddable scripting language. If you need ODBC support for PHP
applications, you will need to install this package and the php
package.

%if %{with_oci8}
%package oci8
Group: Development/Languages
Requires: php-%{subname} = %{version}-%{release}
Summary: A module for PHP applications that use OCI8 databases.
Provides: php_database

%description oci8
The php-oci8 package contains a dynamic shared object that will add
support for accessing OCI8 databases to PHP.
%endif

%if %{with_mssql}
%package mssql
Group: Development/Languages
Requires: php-%{subname} = %{version}-%{release}, freetds
Summary: A module for PHP applications that use MSSQL databases.
Provides: php_database
BuildRequires: freetds-devel

%description mssql
The mssql package contains a dynamic shared object that will add
support for accessing MSSQL databases to PHP.
%endif

%if %{with_mhash}
%package mhash
Summary: A module for PHP applications that use Mhash.
Group: Development/Languages
Requires: php-%{subname} = %{version}-%{release}
BuildRequires: mhash-devel

%description mhash
The php-mhash package is a dynamic shared object (DSO) for the Apache
Web server that adds Mhash support to PHP.
%endif

%package snmp
Summary: A module for PHP applications that query SNMP-managed devices.
Group: Development/Languages
Requires: php-%{subname} = %{version}-%{release}
#BuildRequires: net-snmp-devel, elfutils-devel
BuildRequires: ucd-snmp-devel
Obsoletes: php-apache1-snmp, php-snmp
# elfutils-devel requirement workaround for #103982

%description snmp
The php-snmp package contains a dynamic shared object that will add
support for querying SNMP devices to PHP.  PHP is an HTML-embeddable
scripting language. If you need SNMP support for PHP applications, you
will need to install this package and the php package.

%if %{with_domxml}
%package domxml
Summary: A module for PHP applications which manipulate XML data
Group: Development/Languages
Requires: php-%{subname} = %{version}-%{release}
BuildRequires: libxslt-devel, libxml2-devel >= 2.4.14-1

%description domxml
The php-domxml package contains a dynamic shared object that will add
support for manipulating XML data as a DOM tree to PHP.
%endif

%package xmlrpc
Summary: A module for PHP applications which use the XML-RPC protocol
Group: Development/Languages
Requires: php-%{subname} = %{version}-%{release}
BuildRequires: expat-devel

%description xmlrpc
The php-xmlrpc package contains a dynamic shared object that will add
support for the XML-RPC protocol to PHP.

%prep
%setup -q -n php-%{version}
%patch1 -p1
#%patch2 -p1 -b .config
#%patch3 -p1 -b .lib64
%patch4 -p1 -b .cxx
%patch5 -p1 -b .install
%patch6 -p1 -b .tests
%patch7 -p1 -b .libtool15
#%patch8 -p1 -b .miscfix
#%patch9 -p1 -b .setenv
#%patch10 -p1 -b .xmlrpc
#%patch11 -p1
#%patch12 -p1

%patch21 -p1 -b .odbc
#%patch22 -p1 -b .db4

#%patch30 -p1 -b .dlopen

# Prevent %%doc confusion over LICENSE files
cp Zend/LICENSE Zend/ZEND_LICENSE
cp TSRM/LICENSE TSRM_LICENSE
cp regex/COPYRIGHT regex_COPYRIGHT
cp ext/gd/libgd/README gd_README

# Source is built twice: once for /usr/bin/php, once for the Apache DSO.
mkdir build-cgi build-apache

# Use correct libdir
perl -pi -e 's|%{_prefix}/lib|%{_libdir}|' php.ini-dist

# Remove bogus test; position of read position after fopen(, "a+")
# is not defined by C standard, so don't presume anything.
rm -f ext/standard/tests/file/bug21131.phpt

# Tests that fail.
rm -f ext/standard/tests/file/bug22414.phpt \
      ext/session/tests/019.phpt \
      ext/standard/tests/math/pow.phpt \
      ext/standard/tests/math/round.phpt \
      ext/standard/tests/math/abs.phpt \
      ext/iconv/tests/bug16069.phpt

# branding :-)
#perl -pi -e 's/EXTRA_VERSION=\"\"/EXTRA_VERSION=\" (NORLUG Edition)\"/g' configure*

%build

CFLAGS="$RPM_OPT_FLAGS -Wall -fno-strict-aliasing"; export CFLAGS

# Install extension modules in %{_libdir}/php4.
EXTENSION_DIR=%{_libdir}/php4; export EXTENSION_DIR

# This pulls the static /usr/lib/libc-client.a into the IMAP extension module.
IMAP_SHARED_LIBADD=-lc-client ; export IMAP_SHARED_LIBADD

# pull latest ltmain.sh, AC_PROG_LIBTOOL
#libtoolize --force --copy
# force aclocal run during buildconf
#touch acinclude.m4

# Regenerate configure scripts (patches change config.m4's)
#./buildconf --force

# Shell function to configure and build a PHP tree.
build() {
# bison-1.875-2 seems to produce a broken parser; workaround.
mkdir Zend && cp ../Zend/zend_{language,ini}_{parser,scanner}.[ch] Zend
ln -sf ../configure
%configure \
	--cache-file=../config.cache \
	--with-config-file-path=%{_sysconfdir} \
	--with-config-file-scan-dir=%{_sysconfdir}/php.d \
	--enable-force-cgi-redirect \
	--disable-debug \
	--enable-pic \
	--disable-rpath \
	--enable-inline-optimization \
	--with-bz2 \
	--with-db4=%{_prefix} \
	--with-curl \
	--with-exec-dir=%{_bindir} \
	--with-freetype-dir=%{_prefix} \
	--with-png-dir=%{_prefix} \
	--with-gd \
	--enable-gd-native-ttf \
	--with-gdbm \
	--with-gettext \
	--with-ncurses \
	--with-gmp \
	--with-iconv \
	--with-jpeg-dir=%{_prefix} \
	--with-openssl \
	--with-png \
	--with-pspell \
	--with-regex=system \
	--with-xml \
	--with-expat-dir=%{_prefix} \
	%{?_with_domxml:--with-dom=shared,%{_prefix}} \
        %{?_with_domxml:--with-dom-xslt=%{_prefix} --with-dom-exslt=%{_prefix}} \
        --with-xmlrpc=shared \
        --with-pcre=%{_prefix} \
	--with-zlib \
	--with-layout=GNU \
	--enable-bcmath \
	--enable-exif \
	--enable-ftp \
	--enable-magic-quotes \
	--enable-safe-mode \
	--enable-sockets \
	--enable-sysvsem \
	--enable-sysvshm \
	--enable-discard-path \
	--enable-track-vars \
	--enable-trans-sid \
	--enable-yp \
	--enable-wddx \
	--with-pear=/usr/share/pear \
	--with-imap=shared \
	--with-imap-ssl \
	--with-kerberos \
	--with-ldap=shared \
	--with-mysql=shared,%{_prefix} \
        %{?_with_oci8:--with-oci8=shared} \
        %{?_with_mssql:--with-mssql=shared} \
        %{?_with_mhash:--with-mhash=shared} \
	--with-pgsql=shared \
	--with-snmp=shared,%{_prefix} \
	--with-snmp=shared \
	--enable-ucd-snmp-hack \
	--with-unixODBC=shared \
	--enable-memory-limit \
	--enable-bcmath \
	--enable-shmop \
	--enable-calendar \
	--enable-dbx \
	--enable-dio \
	--enable-mcal \
    --enable-mbstring --enable-mbstr-enc-trans \
    --enable-mbregex \
    --enable-mcrypt \
	$*

#make %{?_smp_mflags}
}

# Build standalone /usr/bin/php
# chip cuccio; breaks on rh-7.3 (12-22-2003)
#pushd build-cgi
#build --enable-force-cgi-redirect
#NO_INTERACTION=1 REPORT_EXIT_STATUS=1 \
#make test || true
#popd

# Build Apache module
#pushd build-apache
#build --with-apxs2=%{_sbindir}/apxs
#popd

#%install
#[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

# Install from CGI tree
# chip cuccio; breaks on rh-7.3 (12-22-2003)
#pushd build-cgi
#make install INSTALL_ROOT=$RPM_BUILD_ROOT 
#popd


# Install the Apache module
#pushd build-apache
#make install-sapi INSTALL_ROOT=$RPM_BUILD_ROOT
#popd

# Second, build an Apache tree.
#
pushd build-apache


# Add the buildroot location to the front of the libexecdir.
# Again use the build() call
#
build --with-apxs2=%{_sbindir}/apxs
popd


%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/usr/lib/{apache,php}

# First, install the CGI tree.
#
#pushd build-cgi
#make install INSTALL_ROOT=$RPM_BUILD_ROOT 
#popd


# Second, install the Apache tree.  Note that this overwrites the modules which
# were installed as part of the CGI build.  Lucky for us they're compatible.
#
pushd build-apache
make install INSTALL_ROOT=$RPM_BUILD_ROOT INSTALL_IT="echo "
popd


# Install the default configuration file and icons
install -m 755 -d $RPM_BUILD_ROOT%{_sysconfdir}/
install -m 644    php.ini-dist $RPM_BUILD_ROOT%{_sysconfdir}/php.ini
# fix PHP .so paths
%{__perl} -pi -e 's|extension_dir = \".\/\"|extension_dir = \"\/usr\/lib\/php4\"|g;' \
    $RPM_BUILD_ROOT%{_sysconfdir}/php.ini
install -m 755 -d $RPM_BUILD_ROOT%{contentdir}/icons
install -m 644    *.gif $RPM_BUILD_ROOT%{contentdir}/icons/

# install the DSO
install -m 755 -d $RPM_BUILD_ROOT%{_libdir}/httpd/modules
install -m 755 build-apache/libs/libphp4.so $RPM_BUILD_ROOT%{_libdir}/httpd/modules

# Apache config fragment
install -m 755 -d $RPM_BUILD_ROOT/etc/httpd/conf.d
install -m 644 $RPM_SOURCE_DIR/php.conf $RPM_BUILD_ROOT/etc/httpd/conf.d

install -m 755 -d $RPM_BUILD_ROOT%{_sysconfdir}/php.d

# things that moved sice 4.3.11 :-/
install -m 755 build-apache/scripts/phpize $RPM_BUILD_ROOT%{_bindir}/
install -m 755 scripts/dev/phpextdist $RPM_BUILD_ROOT%{_bindir}/

# Generate files lists and stub .ini files for each subpackage
for mod in pgsql mysql odbc imap ldap snmp domxml xmlrpc \
    %{?_with_oci8:oci8} %{?_with_mssql:mssql} %{?_with_mhash:mhash}; do
    cat > $RPM_BUILD_ROOT%{_sysconfdir}/php.d/${mod}.ini <<EOF
; Enable ${mod} extension module
extension=${mod}.so
EOF
    cat > files.${mod} <<EOF
%attr(755,root,root) %{_libdir}/php4/${mod}.so
%config(noreplace) %attr(644,root,root) %{_sysconfdir}/php.d/${mod}.ini
EOF
done

# Remove PEAR testsuite
rm -rf $RPM_BUILD_ROOT%{_datadir}/pear/tests

# Remove unpackaged files
rm -f $RPM_BUILD_ROOT%{_libdir}/php4/*.a \
      $RPM_BUILD_ROOT%{_bindir}/{phptar,pearize}

# Remove irrelevant docs
rm README.{Zeus,QNX,CVS-RULES}

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
rm files.*

%files
%defattr(-,root,root)
%doc CODING_STANDARDS CREDITS EXTENSIONS INSTALL LICENSE NEWS README*
%doc Zend/ZEND_* gd_README TSRM_LICENSE regex_COPYRIGHT
%config(noreplace) %{_sysconfdir}/php.ini
%config %{_sysconfdir}/pear.conf
%{_bindir}/php
%{_bindir}/pear
%{_datadir}/pear
%dir %{_libdir}/php4
%{_libdir}/httpd/modules/libphp4.so
%config %{_sysconfdir}/httpd/conf.d/php.conf
%dir %{_sysconfdir}/php.d
%{contentdir}/icons/php.gif

%files devel
%defattr(-,root,root)
%{_bindir}/php-config
%{_bindir}/phpize
%{_bindir}/phpextdist
%{_includedir}/php
%{_libdir}/php

%files pgsql -f files.pgsql

%files mysql -f files.mysql

%post mysql
echo ";extension=mysql.so" >> %{_sysconfdir}/php.ini
if %{__grep} -q "extension=mysql.so" %{_sysconfdir}/php.ini; then
    %{__perl} -pi -e "s|^;extension=mysql.so|extension=mysql.so|" %{_sysconfdir}/php.ini
else
    %{__perl} -pi -e "s|^;extension=php_mysql.dll|;extension=php_mysql.dll\nextension=mysql.so|" %{_sysconfdir}/php.ini
fi

%preun mysql
if [ $1 = 0 -a -f %{_sysconfdir}/php.ini ] ; then
    %{__perl} -pi -e "s|^extension=mysql.so|;extension=mysql.so|" %{_sysconfdir}/php.ini
fi

%files odbc -f files.odbc

%if %{with_oci8}
%files oci8 -f files.oci8
%endif

%if %{with_mssql}
%files mssql -f files.mssql
%endif

%if %{with_mhash}
%files mhash -f files.mhash
%endif

%files imap -f files.imap

%files ldap -f files.ldap

%files snmp -f files.snmp

%if %{with_domxml}
%files domxml -f files.domxml
%endif

%files xmlrpc -f files.xmlrpc

%changelog
* Fri Jan 13 2006 Chip Cuccio <chipster@norlug.org> 4.4.2-1
- update to 4.4.2

* Mon Oct 31 2005 Chip Cuccio <chipster@norlug.org> 4.4.1-1
- updated to 4.4.1
- Happy Halloween

* Mon Jul 11 2005 Chip Cuccio <chipster@norlug.org> 4.4.0-3
- updated to 4.4.0

* Fri Apr 1 2005 Chip Cuccio <chipster@norlug.org> 4.3.11-1
- updated
- enabled mcrpypt

* Thu Dec 16 2004 Chip Cuccio <chipster@norlug.org> 4.3.10-3
- updated

* Sat Oct 9 2004 Chip Cuccio <chipster@norlug.org> 4.3.9-4
- fixed "obsoletes" and "requires" fields

* Fri Sep 24 2004 Chip Cuccio <chipster@norlug.org> 4.3.9-1
- updated

* Tue Jul 13 2004 Chip Cuccio <chipster@norlug.org> 4.3.8.-2
- updated

* Thu Jun 3 2004 Chip Cuccio <chipster@norlug.org> 4.3.7-1
- updated

* Thu Apr 15 2004 Chip Cuccio <chipster@norlug.org> 4.3.6-1
- update to 4.3.6
- added new obsoletes

* Tue Mar 30 2004 Chip Cuccio <chipster@norlug.org> 4.3.5-1
- update to 4.3.5

* Fri Feb 27 2004 Chip Cuccio <chipster@norlug.org> 4.3.4-9
- fixed httpd 2.0 requirement issue.

* Sun Dec 21 2003 Chip Cuccio <chipster@norlug.org> 4.3.4-8
- initial build for rh-7.3
